diff -urN qmail-scanner-1.25.org/configure qmail-scanner-1.25/configure
--- qmail-scanner-1.25.org/configure	2004-10-19 09:26:55.000000000 +0900
+++ qmail-scanner-1.25/configure	2005-04-09 01:31:40.000000000 +0900
@@ -160,7 +160,7 @@
 				     Set to "no" if you want them to be scanned
 				     anyway.
 
-  --notify "none|sender|recips|precips|admin|nmladm|nmlvadm|all" Defaults to "$NOTIFY_ADDRESSES". 
+  --notify "none|sender|psender|lsndr|phsndr|recips|precips|admin|nmladm|nmlvadm|all" Defaults to "$NOTIFY_ADDRESSES". 
 				     Comma-separated list (no spaces!)
 				     of addresses to which alerts should
 				     be sent to. "nmladm" means only
@@ -177,6 +177,13 @@
 				     if their e-mail was blocked for policy reasons. i.e. if an AV system 
 				     found a virus, then don't notify the sender/recip as the address was 
 				     probably forged.
+				     ================ Modified by lsender patch ====================
+				     Two NEW notify options are available - lsndr and phsndr.
+				     If "lsndr" is spcified, Q-S will notify sender ONLY if he belongs
+				     to local-domains. "phsndr" is the same but sender will notified
+				     if also mail was blocked by policy. In both cases, automated mail
+				     (ie. mailing-list) will avoid notification.
+
   --local-domains "one.domain,two.domain" Defaults to the 
 				     value of the "--domain" setting.
 				     Comma-separated list (no spaces!) 
@@ -446,7 +453,7 @@
 if [ "$NOTIFY_ADDRESSES" ]; then
      for addr in `echo $NOTIFY_ADDRESSES|sed 's/,/ /g'`
      do
-	if [ "`echo $addr|egrep -v '^(admin|nmladm|nmlvadm|none|sender|psender|recips|precips|all)$'`" != "" ]; then
+	if [ "`echo $addr|egrep -v '^(admin|nmladm|nmlvadm|none|sender|psender|lsndr|phsndr|recips|precips|all)$'`" != "" ]; then
 	    cat<<EOF
 
 
@@ -462,6 +469,8 @@
 nmlvadm
 sender
 psender
+lsndr
+phsndr
 recips
 precips
 all
diff -urN qmail-scanner-1.25.org/locale/ja_JP.EUC/attention qmail-scanner-1.25/locale/ja_JP.EUC/attention
--- qmail-scanner-1.25.org/locale/ja_JP.EUC/attention	2003-10-16 10:51:57.000000000 +0900
+++ qmail-scanner-1.25/locale/ja_JP.EUC/attention	2005-04-08 00:12:54.000000000 +0900
@@ -1,2 +1 @@
-
-Attention
\ No newline at end of file
+
\ No newline at end of file
diff -urN qmail-scanner-1.25.org/locale/ja_JP.EUC/recips_automated_mail_note qmail-scanner-1.25/locale/ja_JP.EUC/recips_automated_mail_note
--- qmail-scanner-1.25.org/locale/ja_JP.EUC/recips_automated_mail_note	2003-10-16 10:51:57.000000000 +0900
+++ qmail-scanner-1.25/locale/ja_JP.EUC/recips_automated_mail_note	2004-08-12 08:54:24.000000000 +0900
@@ -1,5 +1,5 @@
 
 
-[ȯԤᥤ󥰥ꥹȤޤ¾μưåʤΤǡ
+[ȯ᡼󥰥ꥹȤʤɼưƥΤ褦ʤΤǡ
 ΥåȯԤΥɥ쥹ˤơޤ󡲡]
 
diff -urN qmail-scanner-1.25.org/locale/ja_JP.EUC/recips_content qmail-scanner-1.25/locale/ja_JP.EUC/recips_content
--- qmail-scanner-1.25.org/locale/ja_JP.EUC/recips_content	2003-10-16 10:51:57.000000000 +0900
+++ qmail-scanner-1.25/locale/ja_JP.EUC/recips_content	2005-04-08 21:50:12.000000000 +0900
@@ -2,13 +2,14 @@
 
 %%quarantine_description
 
-ˤˤĤƤʤˤ䤬Ͼ󵻽ôԤ̤Ƥ
+ˤˤĤƤʤˤ䤬ITôԤ̤Ƥ
 
 ʤ줿åϰʲΰ̾񤭤ˤʤäƤޤ:
 
-MAIL FROM: %%returnpath
+MAIL FROM: %%header_from
 RCPT TO:   %%recips 
+SUBJECT:   %%subj_conved
 
-... ưʲΥإåդƤޤ:
+ʤإåϰʲΤ褦ʤΤǤ:
 
 
diff -urN qmail-scanner-1.25.org/locale/ja_JP.EUC/recips_explanation qmail-scanner-1.25/locale/ja_JP.EUC/recips_explanation
--- qmail-scanner-1.25.org/locale/ja_JP.EUC/recips_explanation	2003-10-16 10:51:57.000000000 +0900
+++ qmail-scanner-1.25/locale/ja_JP.EUC/recips_explanation	2005-04-08 21:49:56.000000000 +0900
@@ -1,4 +1,4 @@
-%%destring ʤemailȯޤ
-emailΥʡª
-ΥåΤʤߤޤ
+ʤΥ᡼ %%destring ȯޤ
+᡼륹ʡ륹ª
+ʤۿʤ褦ΥåΤ򥹥ȥåפޤ
 
diff -urN qmail-scanner-1.25.org/locale/ja_JP.EUC/recips_msg_description qmail-scanner-1.25/locale/ja_JP.EUC/recips_msg_description
--- qmail-scanner-1.25.org/locale/ja_JP.EUC/recips_msg_description	2003-10-16 10:51:58.000000000 +0900
+++ qmail-scanner-1.25/locale/ja_JP.EUC/recips_msg_description	2005-04-08 21:49:32.000000000 +0900
@@ -2,13 +2,14 @@
 
 %%quarantine_description
 
-ˤˤĤƤʤˤ䤬Ͼ󵻽ôԤ̤Ƥ
+ˤˤĤƤʤˤ䤬ITôԤ̤Ƥ
 
-ʤ줿åϰʲΰ̾񤭤ˤʤäƤޤ:
+ʤ줿åϰʲΰ̾񤭤ˤʤäƤޤ:
 
-MAIL FROM: %%returnpath
+MAIL FROM: %%header_from
 RCPT TO:   %%recips 
+SUBJECT:   %%subj_conved
 
-... ưʲΥإåդƤޤ:
+ʤإåϰʲΤ褦ʤΤǤ:
 
 
diff -urN qmail-scanner-1.25.org/locale/ja_JP.EUC/recips_not_automated_mail_note qmail-scanner-1.25/locale/ja_JP.EUC/recips_not_automated_mail_note
--- qmail-scanner-1.25.org/locale/ja_JP.EUC/recips_not_automated_mail_note	2003-10-16 10:51:58.000000000 +0900
+++ qmail-scanner-1.25/locale/ja_JP.EUC/recips_not_automated_mail_note	2004-08-12 08:48:18.000000000 +0900
@@ -1,4 +1,4 @@
 
-[ȯ԰ˡबʤäemail˥륹¸ߤƤݤ
-åޤʤ¦ǤϤʾκȤɬפޤ]
+[ʤä᡼˥륹¸ߤƤȤݤΥå
+ȯ԰ޤʤä˲⤹ɬפϤޤ]
 
diff -urN qmail-scanner-1.25.org/locale/ja_JP.EUC/recips_quarantine qmail-scanner-1.25/locale/ja_JP.EUC/recips_quarantine
--- qmail-scanner-1.25.org/locale/ja_JP.EUC/recips_quarantine	2004-01-13 08:43:46.000000000 +0900
+++ qmail-scanner-1.25/locale/ja_JP.EUC/recips_quarantine	2004-08-12 08:45:30.000000000 +0900
@@ -1,12 +1,12 @@
 
 
-ΥåϰʲݴɤƤޤ:
+%%V_FROMNAME ˤܺ٤ʬϤǤ褦
+ΥåϰʲξݴɤƤޤ:
 
   %%hostname:%%scandir/%%vmaildir/new/%%file_id
 
-ǡ%%V_FROMNAME ˿ǤǤޤ.
 
-Υå򥹥󤷤ȤemailʡϰʲΤ褦𤷤ޤ:
+å򥹥󤷤ݤ˥᡼륹ʡ֤ϲ:
 
 --- 
 %%description
diff -urN qmail-scanner-1.25.org/locale/ja_JP.EUC/recips_subject qmail-scanner-1.25/locale/ja_JP.EUC/recips_subject
--- qmail-scanner-1.25.org/locale/ja_JP.EUC/recips_subject	2003-10-16 10:51:58.000000000 +0900
+++ qmail-scanner-1.25/locale/ja_JP.EUC/recips_subject	2004-08-12 11:15:30.000000000 +0900
@@ -1,2 +1,2 @@
-äåȯޤ
+ʤΥå %%destring ȯޤ
 
diff -urN qmail-scanner-1.25.org/locale/ja_JP.EUC/sender_automated_mail_note qmail-scanner-1.25/locale/ja_JP.EUC/sender_automated_mail_note
--- qmail-scanner-1.25.org/locale/ja_JP.EUC/sender_automated_mail_note	2003-10-16 10:51:58.000000000 +0900
+++ qmail-scanner-1.25/locale/ja_JP.EUC/sender_automated_mail_note	2004-08-12 09:01:58.000000000 +0900
@@ -1,4 +1,4 @@
 
 
-[ȯԤᥤ󥰥ꥹȤޤ¾μưåʤΤǡ
+[ȯ᡼󥰥ꥹȤʤɼưƥΤ褦ʤΤǡ
 ΥåȯԤΥɥ쥹ˤơޤ󡲡]
diff -urN qmail-scanner-1.25.org/locale/ja_JP.EUC/sender_explanation qmail-scanner-1.25/locale/ja_JP.EUC/sender_explanation
--- qmail-scanner-1.25.org/locale/ja_JP.EUC/sender_explanation	2003-10-16 10:51:58.000000000 +0900
+++ qmail-scanner-1.25/locale/ja_JP.EUC/sender_explanation	2004-08-12 09:01:18.000000000 +0900
@@ -1,7 +1,7 @@
 
-%%destring ʤäemailȯޤ
-emailΥʡª
-ΥåΤߤޤ
+ʤä᡼ %%destring ȯޤ
+᡼륹ʡ륹ª
+ʤ褦ΥåΤ򥹥ȥåפޤ
 
 Ф줿 %%destring :
 
diff -urN qmail-scanner-1.25.org/locale/ja_JP.EUC/sender_msg_description qmail-scanner-1.25/locale/ja_JP.EUC/sender_msg_description
--- qmail-scanner-1.25.org/locale/ja_JP.EUC/sender_msg_description	2003-10-16 10:51:58.000000000 +0900
+++ qmail-scanner-1.25/locale/ja_JP.EUC/sender_msg_description	2005-04-08 21:00:04.000000000 +0900
@@ -1,11 +1,11 @@
 
+ʤäåϰʲΰ̾񤭤ˤʤäƤޤ:
 
-ʤäåϰʲΰ̾񤭤ˤʤäƤޤ:
-
-MAIL FROM: %%returnpath
+MAIL FROM: %%header_from
 RCPT TO:   %%recips 
+SUBJECT:   %%subj_conved
 
-... ưʲΥإåդƤޤ:
+ʤإåϰʲΤ褦ʤΤǤ:
 
 
 
diff -urN qmail-scanner-1.25.org/locale/ja_JP.EUC/sender_other_content qmail-scanner-1.25/locale/ja_JP.EUC/sender_other_content
--- qmail-scanner-1.25.org/locale/ja_JP.EUC/sender_other_content	2003-10-16 10:51:58.000000000 +0900
+++ qmail-scanner-1.25/locale/ja_JP.EUC/sender_other_content	2005-04-08 21:48:16.000000000 +0900
@@ -1,3 +1,3 @@
 
-ˤˤĤƤʤˤ䤬Ͼ󵻽ôԤ̤Ƥ
+ˤˤĤƤʤˤ䤬ITôԤ̤Ƥ
 
diff -urN qmail-scanner-1.25.org/locale/ja_JP.EUC/sender_quarantine qmail-scanner-1.25/locale/ja_JP.EUC/sender_quarantine
--- qmail-scanner-1.25.org/locale/ja_JP.EUC/sender_quarantine	2004-01-13 08:43:46.000000000 +0900
+++ qmail-scanner-1.25/locale/ja_JP.EUC/sender_quarantine	2004-08-12 08:58:40.000000000 +0900
@@ -1,12 +1,12 @@
 
 
-ΥåϰʲݴɤƤޤ:
+%%V_FROMNAME ˤܺ٤ʬϤǤ褦
+ΥåϰʲξݴɤƤޤ:
 
   %%hostname:%%scandir/%%vmaildir/new/%%file_id
 
-ǡ%%V_FROMNAME ˿ǤǤޤ.
 
-Υå򥹥󤷤ȤemailʡϰʲΤ褦𤷤ޤ:
+å򥹥󤷤ݤ˥᡼륹ʡ֤ϲ:
 
 --- 
 %%description
diff -urN qmail-scanner-1.25.org/locale/ja_JP.EUC/sender_subject qmail-scanner-1.25/locale/ja_JP.EUC/sender_subject
--- qmail-scanner-1.25.org/locale/ja_JP.EUC/sender_subject	2003-10-16 10:51:58.000000000 +0900
+++ qmail-scanner-1.25/locale/ja_JP.EUC/sender_subject	2004-08-12 11:16:54.000000000 +0900
@@ -1 +1 @@
-äåȯޤ
+ʤäå %%destring ȯޤ
diff -urN qmail-scanner-1.25.org/locale/ja_JP.EUC/sender_virus_content qmail-scanner-1.25/locale/ja_JP.EUC/sender_virus_content
--- qmail-scanner-1.25.org/locale/ja_JP.EUC/sender_virus_content	2003-10-16 10:51:58.000000000 +0900
+++ qmail-scanner-1.25/locale/ja_JP.EUC/sender_virus_content	2005-04-08 21:47:32.000000000 +0900
@@ -1,5 +1,5 @@
 
-¨濫ʤΥ륹ХեȤ򹹿뤫
-ʤΥƥ˥륹Ƥݤ
-󵻽ôԤϢƤ
+ˤʤΥ륹ХեȤ򹹿뤫
+ʤΥƥब륹˴Ƥݤ
+ITôԤϢƤ
 
diff -urN qmail-scanner-1.25.org/qmail-scanner-queue.template qmail-scanner-1.25/qmail-scanner-queue.template
--- qmail-scanner-1.25.org/qmail-scanner-queue.template	2005-01-28 07:51:58.000000000 +0900
+++ qmail-scanner-1.25/qmail-scanner-queue.template	2005-04-09 00:52:46.000000000 +0900
@@ -270,6 +270,7 @@
 my @uufile_list = ();
 my @attachment_list = ();
 my @zipfile_list = ();
+my $sent_to_sender = '0';
 
 #Want microsec times for debugging
 use Time::HiRes qw( usleep ualarm gettimeofday tv_interval );
@@ -279,6 +280,9 @@
 
 use Getopt::Std;
 
+use Jcode;
+use MIME::Base64;
+
 #my ($opt_v,$opt_h,$opt_g,$opt_r,$opt_z);
 
 getopts('vhgrz');
@@ -1411,7 +1415,17 @@
       }
     }
   } else {
-    $is_local="99";
+    if ($addr_type eq "lsndr") {
+      foreach $dom (@local_domains_array) {
+        #&debug("i_u_e: does $returnpath contain $dom?");
+        if ($returnpath =~ /$dom$/i) {
+          #&debug("i_u_e: yes it does!");
+          $is_local++;
+        }
+      }
+    } else {
+      $is_local="99";
+    }
     if (&automated_msg ) {
       #&debug("i_u_e: $addr_type is a mailing-list");
       return 1;
@@ -1428,6 +1442,26 @@
   }
 }
 
+sub consider_sender_local {
+  # Check if we need and are able to notify local senders
+  # Arg is lsndr, phsndr or any
+  my($sender_type) = @_;
+  if ( ($sender_type eq "any" && (&notify_addr('lsndr') || &notify_addr('phsndr'))) || ($sender_type ne "any" && &notify_addr($sender_type)) ) {
+    if (&notify_addr('phsndr') || $sender_type eq "phsndr") {
+      unless ($quarantine_event =~ /^(policy|perlscan)/i && $quarantine_event !~ /virus/i) {
+        &debug("c_s_l: should sender get alarm mail? ($sender_type) : No");
+        return 0;
+      }
+    }
+    if (!&is_unreplyable_email('lsndr')) {
+      &debug("c_s_l: should sender get alarm mail? ($sender_type) : Yes");
+      return 1;
+    }
+  }
+  &debug("c_s_l: should sender get alarm mail? ($sender_type) : No");
+  return 0;
+}
+
 sub email_quarantine_report {
   my($start_email_time)=[gettimeofday];
   &debug("e_v_r: quarantine  msg to $scandir/$vmaildir/new/$file_id");
@@ -1864,6 +1898,17 @@
   print "\n\n\n";
 }
 
+sub to_jis {
+  my $str = shift;
+  my $jopt = shift;
+  my $j = jcode($str);
+  if ( $jopt eq 'mime') {
+    $str = $j->mime_encode();
+  } else {
+    $str = $j->jis;
+  }
+  return $str;
+}
 
 sub email_sender {
   #Don't e-mail bounced mail messages/etc!
@@ -1874,14 +1919,22 @@
   $polstring='policy' if (&notify_addr('nmlvadm'));
 
   open(SM,"|$qmailinject -h -f ''")||&error_condition("cannot open $qmailinject for sending quarantine report - $!");
-  print SM "From: \"$V_FROMNAME\" <$V_FROM>\n";
+  my $msg_fromname = &to_jis($V_FROMNAME);
+  print SM "From: \"$msg_fromname\" <$V_FROM>\n";
   if ($addr_type =~ /sender/) {
-    $addr_type='psender' if ($NOTIFY_ADDRS =~ /psender/);
+    if ($NOTIFY_ADDRS =~ /phsndr/) {
+      $addr_type='phsndr';
+    } elsif ($NOTIFY_ADDRS =~ /lsndr/) {
+      $addr_type='lsndr';
+    } elsif ($NOTIFY_ADDRS =~ /psender/) {
+      $addr_type='psender';
+    }
     if ($addr_type eq "sender") {
       if (!&is_unreplyable_email('sender') && &notify_addr('sender')) {
 	&debug("e_s: sending quarantine report via: $qmailinject to sender address ($returnpath)");
 	print SM "To: $returnpath\n";
 	$tmpsndrs = "$returnpath";
+	$sent_to_sender = '1';
       } else {
 	&debug("e_s: don't notify sender");
       }
@@ -1890,9 +1943,28 @@
 	&debug("e_s: sending policy quarantine report via: $qmailinject to psender address ($returnpath)");
 	print SM "To: $returnpath\n";
 	$tmpsndrs = "$returnpath";
+	$sent_to_sender = '1';
       } else {
 	&debug("e_s: don't notify psender");
       }
+    }elsif ($addr_type eq "lsndr") {
+      if (&consider_sender_local('lsndr')) {
+        &debug("e_s: sending policy quarantine report via: $qmailinject to lsndr address ($returnpath)");
+        print SM "To: $returnpath\n";
+        $tmpsndrs = "$returnpath";
+        $sent_to_sender = '1';
+      } else {
+        &debug("e_s: don't notify lsndr");
+      }
+    }elsif ($addr_type eq "phsndr") {
+      if (&consider_sender_local('phsndr')) {
+        &debug("e_s: sending policy quarantine report via: $qmailinject to phsndr address ($returnpath)");
+        print SM "To: $returnpath\n";
+        $tmpsndrs = "$returnpath";
+        $sent_to_sender = '1';
+      } else {
+        &debug("e_s: don't notify phsndr");
+      }
     } else {
       return;
     }
@@ -1905,8 +1977,15 @@
       &debug("e_s: don't notify admin");
     }
   }
-  $tmpsubj="$destring LOCALE_sender_subject \"$headers{'subject'}\"";
+  my $subj_conved = $headers{'subject'};
+  if ( $subj_conved =~ /=\?.+-jp\?.*\?=/i ) {
+    $subj_conved =~ s/(\r|\0|\n)/ /g;
+    my $j = jcode($subj_conved);
+    $subj_conved = $j->mime_decode->euc;
+  }
+  $tmpsubj = "LOCALE_sender_subject \"$subj_conved\"";
   $tmpsubj =~ s/(\r|\0|\n)/ /g;
+  $tmpsubj = &to_jis($tmpsubj,'mime');
   print SM "Subject: $tmpsubj\n";
   print SM "Message-ID: <".&uniq_id."\@$hostname>\n";
   print SM "X-Tnz-Problem-Type: 40\n";
@@ -1916,7 +1995,7 @@
     print SM "References: ",$headers{'message-id'},"\n";
   }
   print SM "MIME-Version: 1.0\n";
-  print SM "Content-type: text/plain\n";
+  print SM "Content-type: text/plain; charset=\"ISO-2022-JP\"\n";
   if ( $descriptive_hdrs ) {
     print SM "${V_HEADER}-Mail-From: $returnpath via $hostname\n";
     print SM "${V_HEADER}-Rcpt-To: $recips\n" if ($descriptive_hdrs eq "2");
@@ -1925,25 +2004,43 @@
   }
   print SM "\n";
   if (&is_unreplyable_email('sender')) {
-    print SM "LOCALE_attention: $V_FROMNAME.\n";
-    print SM "LOCALE_sender_automated_mail_note\n";
+    my $attention = "$V_FROMNAME LOCALE_attention";
+    $attention = &to_jis($attention);
+    my $sender_auto_note = "LOCALE_sender_automated_mail_note";
+    $sender_auto_note = &to_jis($sender_auto_note);
+	print SM "\n$attention\n";
+    print SM "$sender_auto_note\n";
     print SM "\n---------------------------------------\n\n";
   } else {
-    print SM "LOCALE_attention: $returnpath\n";
-  }
-  print SM "\nLOCALE_sender_explanation\n";
+    my $attention = "$returnpath LOCALE_attention";
+    $attention = &to_jis($attention);
+    print SM "\n$attention\n";
+  }
+  my $sender_explain = "LOCALE_sender_explanation";
+  $sender_explain = &to_jis($sender_explain);
+  print SM "\n$sender_explain\n";
   if ($destring eq "virus") {
-    print SM "\nLOCALE_sender_virus_content\n";
+    my $sender_vir_cont = "LOCALE_sender_virus_content";
+    $sender_vir_cont = &to_jis($sender_vir_cont);
+    print SM "\n$sender_vir_cont\n";
   } else {
-    print SM "\nLOCALE_sender_other_content\n";
-  }
-  print SM "\nLOCALE_sender_msg_description\n\n";
+    my $sender_other_cont = "LOCALE_sender_other_content";
+    $sender_other_cont = &to_jis($sender_other_cont);
+    print SM "\n$sender_other_cont\n";
+  }
+  my $header_from = $headers{'MAILFROM'};
+  $header_from = &to_jis($header_from);
+  my $sender_msg_desc = "LOCALE_sender_msg_description";
+  $sender_msg_desc = &to_jis($sender_msg_desc);
+  print SM "\n$sender_msg_desc\n\n";
   print SM "---\n";
-  print SM "MAILFROM: $headers{'MAILFROM'}\n";
+  print SM "MAILFROM: $header_from\n";
   print SM "$HEADERS\n";
   print SM "---\n";
-  if ($addr_type ne "sender" ) {
-    print SM "\nLOCALE_sender_quarantine\n";
+  if ($addr_type ne "sender" && $addr_type ne "lsndr" && $addr_type ne "phsndr") {
+    my $sender_quarant = "LOCALE_sender_quarantine";
+    $sender_quarant = &to_jis($sender_quarant);
+    print SM "\n$sender_quarant\n";
   }
   close(SM);
   if ($log_details) {
@@ -1966,13 +2063,21 @@
   my($tmpmsgid)= &uniq_id() . "-" . $V_FROM;
 
   open(SM,"|$qmailinject -h -f ''")||&error_condition("cannot open $qmailinject for sending quarantine report - $!");
-  print SM "From: \"$V_FROMNAME\" <$V_FROM>\n";
+  my $msg_fromname = &to_jis($V_FROMNAME);
+  print SM "From: \"$msg_fromname\" <$V_FROM>\n";
   if (!&is_unreplyable_email('recips')) {
     &debug("e_r: sending quarantine report via: $qmailinject to recip address ($recip)");
     print SM "To: $recip\n";
   }
-  $tmpsubj= "$destring LOCALE_recips_subject \"$headers{'subject'}\"";
+  my $subj_conved = $headers{'subject'};
+  if ( $subj_conved =~ /=\?.+-jp\?.*\?=/i ) {
+    $subj_conved =~ s/(\r|\0|\n)/ /g;
+    my $j = jcode($subj_conved);
+    $subj_conved = $j->mime_decode->euc;
+  }
+  $tmpsubj = "LOCALE_recips_subject \"$subj_conved\"";
   $tmpsubj =~ s/(\r|\0|\n)/ /g;
+  $tmpsubj = &to_jis($tmpsubj,'mime');
   print SM "Subject: $tmpsubj\n";
   print SM "Message-ID: <".&uniq_id."\@$hostname>\n";
   print SM "X-Tnz-Problem-Type: 40\n";
@@ -1982,26 +2087,41 @@
   }
   print SM "Auto-Submitted: auto-replied\n";
   print SM "MIME-Version: 1.0\n";
-  print SM "Content-type: text/plain\n";
+  print SM "Content-type: text/plain; charset=\"ISO-2022-JP\"\n";
   if ( $descriptive_hdrs ) {
     print SM "${V_HEADER}-Mail-From: $returnpath via $hostname\n";
     print SM "${V_HEADER}-Rcpt-To: $recip\n" if ($descriptive_hdrs eq "2");
     print SM "$V_HEADER: $VERSION ($SCANINFO $destring Found. \n";
     print SM " Processed in ",tv_interval($start_time,[gettimeofday])," secs)\n";
   }
+  my $attention = "$recip LOCALE_attention";
+  $attention = &to_jis($attention);
   print SM "\n";
-  print SM "LOCALE_attention: $recip\n";
-  if (!&is_unreplyable_email('recips')) {
-    if (&notify_addr('sender')) {
-      print SM "LOCALE_recips_not_automated_mail_note\n";
-    }
+  print SM "\n$attention\n";
+  if ($sent_to_sender) {
+    &debug("e_r: has notified sender: Yes");
   } else {
-    print SM "LOCALE_recips_automated_mail_note\n";
+    &debug("e_r: has notified sender: No");
   }
-  print SM "\nLOCALE_recips_explanation\n";
-  print SM "\nLOCALE_recips_msg_description\n\n";
+  if (!&is_unreplyable_email('recips') && $sent_to_sender) {
+    my $rcps_noauto_note = "LOCALE_recips_not_automated_mail_note";
+    $rcps_noauto_note = &to_jis($rcps_noauto_note);
+    print SM "$rcps_noauto_note\n";
+  } elsif (&automated_msg) {
+    my $rcps_auto_note = "LOCALE_recips_automated_mail_note";
+    $rcps_auto_note = &to_jis($rcps_auto_note);
+    print SM "$rcps_auto_note\n";
+  }
+  my $rcps_explain = "LOCALE_recips_explanation";
+  $rcps_explain = &to_jis($rcps_explain);
+  my $header_from = $headers{'MAILFROM'};
+  $header_from = &to_jis($header_from);
+  my $rcps_msg_desc = "LOCALE_recips_msg_description";
+  $rcps_msg_desc = &to_jis($rcps_msg_desc);
+  print SM "\n$rcps_explain\n";
+  print SM "\n$rcps_msg_desc\n\n";
   print SM "---\n";
-  print SM "MAILFROM: $headers{'MAILFROM'}\n";
+  print SM "MAILFROM: $header_from\n";
   print SM "$HEADERS\n";
   print SM "---\n";
   #print SM "\nLxOCALE_recips_quarantine\n";
